function RequestBasedFilter(name) {
    this.name = name;
    this.params = {};
    this.paramsMeta = [];
    this.jsCallback = null;
    this.getName = function () {
        return this.name;
    }
    this.setParam = function (name, value) {
        this.params[name] = value;
        return this;
    }
    this.getParam = function (name) {
        return this.params[name];
    }
    this.getParams = function () {
        return this.params;
    }
    this.addParamMeta = function (name, requestName, defaultValue) {
        this.paramsMeta.push({
            name: name,
            requestName:requestName,
            defaultValue:defaultValue
        });
        this.params[name] = defaultValue;
        return this;
    }
    this.getParamsMeta = function () {
        return this.paramsMeta;
    }

    this.getProcessedParams = function () {
        var processed = {};
        for (var i in this.params)
            processed[i] = JSON.stringify(this.params[i]);
        return processed;
    }

    this.setJsCallback = function(callback) {
        this.jsCallback = callback;
        return this;
    }

    this.callback = function() {
        if (this.jsCallback != null && typeof this.jsCallback != 'undefined')
            this.jsCallback(this);
    }

    this._testRedirect = function() {
        var p = this.getProcessedParams();
        var url = location.href;
        if (url.indexOf('?') == -1)
            url += "?";
        for (i in p)
        {
            url += "&" + i + "=" + p[i];
        }
        location.href = url;
    }
    this.setObjectAttr = function(key, value) {
        this[key] = value;
        return this;
    }
}